//Nesscessary Include Files
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "parameters.h"


//Required Function Prototypes
double uniform_distribution( double min, double max);
double gaussian_distribution( double mean, double variance);


void AWGN_Channel(volatile double* BPSK_AWGN_Codeword)
{
	
	volatile int i;

	volatile double snr;
	volatile double No;
	volatile double Noise_Sigma;
	
	
	snr = pow(10.0,SNRdB/10.0);

	No = 2.0/snr; 
	 
	Noise_Sigma = sqrt(No/2.0);


    //BPSK Modulate into 1's and -1's
    for(i = 0; i < COLUMNS; i++)
		BPSK_AWGN_Codeword[i] = BPSK_AWGN_Codeword[i]*2 - 1;  
	
	//ADD Noise to Random Gaussian Noise to Codeword
	

	for(i = 0; i < COLUMNS; i++)
		BPSK_AWGN_Codeword[i] = BPSK_AWGN_Codeword[i]*sqrt(ES) +  gaussian_distribution(0.0, Noise_Sigma*Noise_Sigma);
	
}



double uniform_distribution( double min, double max)
{
	double result;

	result = (double) rand()/RAND_MAX;
	result = result*(max - min) + min;

	return (result);

}


double gaussian_distribution( double mean, double variance)
{

	double u1, u2, g1, g2;

	while( ( u1 = uniform_distribution (0.0, 1.0)) == 0.0);

	u2 = uniform_distribution (0.0, 1.0);

	g1 = sqrt(-2*variance*log(u1))*cos(2*PI*u2) + mean;
	g2 = sqrt(-2*variance*log(u1))*sin(2*PI*u2) + mean;

	return(g2);
}