#include <stdlib.h>
#include <stdio.h>

#include "parameters.h"



void LDPC_Encoder(volatile double* Codeword)
{
	volatile int i;
	volatile int j;
	volatile char temp;


	volatile char Message[MESSAGE_LENGTH];
	volatile char Temp_Codeword[COLUMNS];
    char G_Matrix[MESSAGE_LENGTH][COLUMNS];


	FILE* g_matrix;

	
	
	//Open G Matrix File Generated by Matlab for reading
	g_matrix   = fopen(g_matrix_fn, "r");



	//Read in Matrix into memory
	for(i = 0; i < MESSAGE_LENGTH; i++)
         for(j=0; j< COLUMNS; j++)
         {
            fscanf(g_matrix,"%d",&temp);
			G_Matrix[i][j] =  temp;
		 }

	fclose(g_matrix);


	//Generate Random Message Bits
	for(i=0; i< MESSAGE_LENGTH; i++)
	{
    	Message[i] =  rand()%2;

		if(Message[i] < 0)
			Message[i] = -Message[i];


		Message[i] =  0; //GENERATE ALL ) 0 CODEWORD
	}


	
	//Initialize Codeword to Zero
	for( i=0; i < COLUMNS; i++)
	{
		Codeword[i] = 0;
		Temp_Codeword[i] = 0;
	}


	//Generate Codeword via modulus 2 multiplication of G Matrix with Message Bits
	 for (j = 0; j < COLUMNS; j++)
     {
         	 
		 for (i = 0; i < MESSAGE_LENGTH; i++)
           	Temp_Codeword[j] +=  (Message[i] * G_Matrix[i][j]);

		 Temp_Codeword[j] %= 2;
         
         Codeword[j] =  (double) Temp_Codeword[j];

	}

}