#include "parameters.h"
#include "AWGN_Channel.c"
#include "LDPC_decoder.c"
#include "LDPC_Encoder.c"
#include <time.h>


void main()
{
	volatile double Code_Vector[COLUMNS];
	volatile double Original_Code_Vector[COLUMNS];
	FILE* main_out;
	int i;
	int bit_errors;

	
	time_t Random_Seed;



	srand( time(&Random_Seed) );


	main_out = fopen("main_output.txt","w");

	LDPC_Encoder(Code_Vector);

	for(i = 0; i< COLUMNS; i++)
		Original_Code_Vector[i] = Code_Vector[i];

	
	fprintf(main_out,"Generated Message Encoded:\n");
	for(i = 0; i< COLUMNS; i++)
		fprintf(main_out,"%1.0f ",Code_Vector[i]);

	AWGN_Channel(Code_Vector);
	fprintf(main_out,"\n\n\nMessage W/ Noise:\n");
	for(i = 0; i< COLUMNS; i++)
		fprintf(main_out,"%3.2f ",Code_Vector[i]);

	LDPC_Decoder(Code_Vector);
	fprintf(main_out,"\n\n\nDecoded Message:\n");
	for(i = 0; i< COLUMNS; i++)
		fprintf(main_out,"%1.0f ",Code_Vector[i]);

	
	bit_errors = 0;

	for(i = (COLUMNS - MESSAGE_LENGTH); i < COLUMNS; i++)
		if(Original_Code_Vector[i] != Code_Vector[i])
			bit_errors++;

	fprintf(main_out,"\n\n\n%i Bit ERRORS!", bit_errors);
	

	
	fclose(main_out);

}